#include <stdio.h>
#include <stdlib.h>
#include <sys/io.h>

#define set_ai_write outb(5,port_a);		// ninit=1, nwrite=0
#define set_data_write outb(1,port_a);	// ninit=0, nwrite=0
#define set_data_read outb(0,port_a);	// ninit=0, nwrite=1
#define set_normal outb(4,port_a);		// ninit=1, nwrite=1

char *file_name=NULL;
const unsigned int port_8=0x378,port_9=0x379,port_a=0x37a,port_b=0x37b,port_c=0x37c;
int i,j,page,sel,err,wv_mode;
char ch=' ';

void set_ai(unsigned char _ai)
{
   set_ai_write			// ninit=1, nwrite=0
   outb(_ai,port_b);
}

void set_ai_data(unsigned char _ai,unsigned char _data)
{
   set_ai(_ai);
   set_data_write		// ninit=0, nwrite=0
   outb(_data,port_c);
}

void init_port(void)
{
   outb(1,port_9);		// clear EPP time flag
   set_ai_data(6,0x0a);
   set_ai_data(7,0x05);		// 6==0x0a, 7==0x05 is pc_control mode
//   set_ai(5);
//   set_data_read
//   write_en=inb(port_c);
   set_ai_data(5,1);      // d0=0 is write protect mode
}

void end_port(void)
{
   set_ai_data(5,1);      // d0=0 is write protect mode
   set_ai_data(7,0);		// release pc mode
   set_ai_data(6,0);		// 6==0x0a, 7==0x05 is pc_control mode
   set_normal        // ninit=1, nWrite=1
}

// set up to read from a given addres
void setadr(unsigned long adr) {
   init_port();
   set_ai_data(3,((adr&0x1f000000)>>24)|0x10);
   set_ai_data(2,(adr&0x00ff0000)>>16);
   set_ai_data(1,(adr&0x0000ff00)>>8);
   set_ai_data(0,(adr&0xff));
   set_ai(4);
   set_data_read
   return;
}

unsigned char check_card(void)
{
   init_port();
   set_ai_data(3,0x12);
   set_ai_data(2,0x34);
   set_ai_data(1,0x56);
   set_ai_data(0,0x78);
   set_ai(3);
   set_data_read		// ninit=0, nwrite=1
   if ((inb(port_c)&0x1f)!=0x12) return(1);
   set_ai(2);
   set_data_read		// ninit=0, nwrite=1
   if (inb(port_c)!=0x34) return(1);
   set_ai(1);
   set_data_read		// ninit=0, nwrite=1
   if (inb(port_c)!=0x56) return(1);
   set_ai(0);
   set_data_read		// ninit=0, nwrite=1
   if (inb(port_c)!=0x78) return(1);
   end_port();
   return(0);
}

void initdrjr(void) {
   char card_present;

   card_present=0;
   if (ioperm(port_8,6,1)) {
       fprintf(stderr,"\ncouldn't get port permissions!\n");
       exit(-1);
   }
   if (check_card()==0){
	 card_present=1;
   }

   if (card_present==0){
      fprintf(stderr,"\nNo V64jr card present!!!\07\n\n");
      exit(-1);
   }

   init_port();
   set_ai(3);
   set_data_read
   inb(port_c);

   fprintf(stderr,"V64jr card found at port %#x\nWrite protect mode turned off\n\n",port_8);
}

int main(int argc, char *argv[])
{
   fprintf(stderr,"Dump drjr ram\n"
              "Transfer based on Bung's drjr source.\n");

   initdrjr();

   unsigned int start,length;

   if (argc != 4 || sscanf(argv[2],"%x",&start)!=1 ||
           sscanf(argv[3],"%x",&length)!=1) {
      fprintf(stderr,"usage: %s file.bin 0xstart 0xlength\n",argv[0]);

      end_port();
      return 1;
   }

   FILE * outfile = fopen(argv[1],"wb");

   if (!outfile) {
      fprintf(stderr,"\nFailed opening output file.\n");
      return 1;
   }


   fprintf(stderr,"Dumping");
   {
       int i;
       for (i=0;i<length;i+=2) {
           if (!(i&0x1ff)) {
               setadr(start+i);
           }
           int buf;
           buf=inw(port_c);
           buf = ((buf&0xff) << 8) | ((buf >> 8)&0xff);
           fwrite(&buf,2,1,outfile);
           if (!(i&0x7fff)) fprintf(stderr,".");
      }
   }
   fprintf(stderr," Done.\n");

   fclose(outfile); outfile=NULL;
   end_port();

   return 0;
}

